Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/ice.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 4220)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 4332)
@@ -292,6 +292,4 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   dh_i_surf2D, dh_i_bott2D, fstbif, fsup2D, focea2D, q_s
 
-   INTEGER , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   patho_case ! number of the pathological case (if any, of course)
-
    !!--------------------------------------------------------------------------
    !! * Ice global state variables
@@ -396,6 +394,6 @@
    LOGICAL               , PUBLIC ::   ln_limdyn     = .TRUE.             !: flag for ice dynamics (T) or not (F)
    LOGICAL               , PUBLIC ::   ln_nicep      = .FALSE.             !: flag for sea-ice points output (T) or not (F)
-   REAL(wp)              , PUBLIC ::   cai           = 1.40e-3            !: atmospheric drag over sea ice
-   REAL(wp)              , PUBLIC ::   cao           = 1.00e-3            !: atmospheric drag over ocean
+   REAL(wp)              , PUBLIC ::   cai           = 1.4e-3            !: atmospheric drag over sea ice
+   REAL(wp)              , PUBLIC ::   cao           = 1.0e-3            !: atmospheric drag over ocean
    REAL(wp)              , PUBLIC ::   amax          = 0.99               !: maximum ice concentration
    !
@@ -465,7 +463,4 @@
          &      fsup2D     (jpi,jpj) , focea2D    (jpi,jpj) , q_s   (jpi,jpj) , STAT=ierr(ii) )
 
-      ii = ii + 1
-      ALLOCATE( patho_case(jpi, jpj, jpl)  , STAT=ierr(ii) )
-
       ! * Ice global state variables
       ii = ii + 1
Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/iceini.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/iceini.F90	(revision 4220)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/iceini.F90	(revision 4332)
@@ -88,5 +88,5 @@
       !
       !                                ! Initial sea-ice state
-      IF( .NOT.ln_rstart ) THEN              ! start from rest
+      IF( .NOT. ln_rstart ) THEN              ! start from rest
          numit = 0
          numit = nit000 - 1
@@ -101,8 +101,10 @@
       ENDIF
       !
-      CALL lim_sbc_init                ! ice surface boundary condition   
-      !
-      fr_i(:,:) = at_i(:,:)           ! initialisation of sea-ice fraction
-      tn_ice(:,:,:) = t_su(:,:,:)
+      hi_max(jpl) = 99._wp  ! Set hi_max(jpl) to a big value to ensure that all ice is thinner than hi_max(jpl)
+      !
+      CALL lim_sbc_init                 ! ice surface boundary condition   
+      !
+      fr_i(:,:) = at_i(:,:)             ! initialisation of sea-ice fraction
+      tn_ice(:,:,:) = t_su(:,:,:)       ! initialisation of surface temp for coupled simu
       !
       nstart = numit  + nn_fsbc      
@@ -132,8 +134,8 @@
       READ  ( numnam_ice , namicerun )
       !
-      IF( lk_mpp .AND. ln_nicep ) THEN
-         ln_nicep = .FALSE.
-         CALL ctl_warn( 'ice_run : specific control print for LIM3 desactivated with MPI' )
-      ENDIF
+      !IF( lk_mpp .AND. ln_nicep ) THEN
+      !   ln_nicep = .FALSE.
+      !   CALL ctl_warn( 'ice_run : specific control print for LIM3 desactivated with MPI' )
+      !ENDIF
       !
       IF(lwp) THEN                        ! control print
@@ -159,4 +161,6 @@
       !! ** Purpose :   Initializes the ice thickness distribution
       !! ** Method  :   ...
+      !!    Note    : hi_max(jpl) is here set up to a value close to 7 m for
+      !!              limistate (only) and is changed to 99 m in ice_init
       !!------------------------------------------------------------------
       INTEGER  ::   jl, jm               ! dummy loop index
Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limcat_1D.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limcat_1D.F90	(revision 4220)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limcat_1D.F90	(revision 4332)
@@ -44,6 +44,8 @@
       REAL(wp), DIMENSION(:),   INTENT(in)    ::   zhti, zhts, zai    ! input ice/snow variables
       REAL(wp), DIMENSION(:,:), INTENT(inout) ::   zht_i, zht_s, za_i ! output ice/snow variables
-      REAL(wp) :: epsi06 = 1.0e-6
-  
+      REAL(wp)                     ::   epsi06 = 1.0e-6
+      REAL(wp)                     ::   zc1, zc2, zc3, zx1, zdh   ! local scalars
+      REAL(wp), DIMENSION(0:jpl)   ::   zhi_max         !:Boundary of ice thickness categories in thickness space
+ 
       IF( nn_timing == 1 )  CALL timing_start('limcat_1D')
       !--------------------------------------------------------------------
@@ -51,7 +53,7 @@
       !--------------------------------------------------------------------
       ijpij = SIZE(zhti,1)
-      zht_i(1:ijpij,1:jpl) = 0.d0
-      zht_s(1:ijpij,1:jpl) = 0.d0
-      za_i (1:ijpij,1:jpl) = 0.d0
+      zht_i(1:ijpij,1:jpl) = 0._wp
+      zht_s(1:ijpij,1:jpl) = 0._wp
+      za_i (1:ijpij,1:jpl) = 0._wp
 
       !------------------------------------------------------------------------------------
@@ -66,4 +68,16 @@
       !         fulfills ice volume concervation between input and output (ztests=4) 
       !--------------------------------------------------------------------------------------
+
+      !- Thickness categories boundaries
+      !    hi_max is calculated in iceini.F90 but since limcat_1D.F90 routine 
+      !    is called before (in bdydta.F90), one must recalculate it.   
+      !    Note clem: there may be a way of doing things cleaner
+      !----------------------------------
+      zhi_max(:) = 0._wp
+      zc1 =  3._wp / REAL( jpl , wp ) ; zc2 = 10._wp * zc1 ; zc3 =  3._wp
+      DO jl = 1, jpl
+         zx1 = REAL( jl-1 , wp ) / REAL( jpl , wp )
+         zhi_max(jl) = zhi_max(jl-1) + zc1 + zc2 * ( 1._wp + TANH( zc3 * ( zx1 - 1._wp ) ) )
+      END DO
  
       ! ----------------------------------------
@@ -71,7 +85,7 @@
       ! ----------------------------------------
       DO ji = 1, ijpij
-        ! snow thickness in each category 
-         zht_s(ji,1:jpl) = zhts(ji)
          
+         IF( zhti(ji) > 0._wp ) THEN
+
          ! initialisation of tests
          ztest_1 = 0
@@ -87,6 +101,6 @@
             
             ! initialisation of ice variables for each try
-            zht_i(ji,1:jpl) = 0.d0
-            za_i (ji,1:jpl) = 0.d0
+            zht_i(ji,1:jpl) = 0._wp
+            za_i (ji,1:jpl) = 0._wp
             
             ! *** case very thin ice: fill only category 1
@@ -94,5 +108,4 @@
                zht_i(ji,1) = zhti(ji)
                za_i (ji,1) = zai (ji)
-               
                ! *** case ice is thicker: fill categories >1
             ELSE
@@ -100,5 +113,5 @@
                ! Fill ice thicknesses except the last one (i_fill) by (hmax-hmin)/2 
                DO jl = 1, i_fill - 1
-                  zht_i(ji,jl) = ( hi_max(jl) + hi_max(jl-1) ) / 2.
+                  zht_i(ji,jl) = ( zhi_max(jl) + zhi_max(jl-1) ) * 0.5_wp
                END DO
                
@@ -106,5 +119,5 @@
                jl0 = i_fill
                DO jl = 1, i_fill
-                  IF ( ( zhti(ji) >= hi_max(jl-1) ) .AND. ( zhti(ji) < hi_max(jl) ) ) THEN
+                  IF ( ( zhti(ji) >= zhi_max(jl-1) ) .AND. ( zhti(ji) < zhi_max(jl) ) ) THEN
                      jl0 = jl
 		     CYCLE
@@ -116,5 +129,5 @@
                DO jl = 1, i_fill - 1
                   IF ( jl == jl0 ) CYCLE
-                  zarg           = ( zht_i(ji,jl) - zhti(ji) ) / ( zhti(ji) / 2. )
+                  zarg           = ( zht_i(ji,jl) - zhti(ji) ) / ( zhti(ji) * 0.5_wp )
                   za_i(ji,jl) =   za_i (ji,jl0) * EXP(-zarg**2)
                END DO
@@ -141,10 +154,10 @@
             
             ! Test 3: thickness of the last category is in-bounds ?
-            IF ( zht_i(ji,i_fill) >= hi_max(i_fill-1) ) ztest_3 = 1
+            IF ( zht_i(ji,i_fill) >= zhi_max(i_fill-1) ) ztest_3 = 1
             
             ! Test 4: positivity of ice concentrations
             ztest_4 = 1
             DO jl = 1, i_fill
-               IF ( za_i(ji,jl) < 0.0d0 ) ztest_4 = 0
+               IF ( za_i(ji,jl) < 0._wp ) ztest_4 = 0
             END DO
             
@@ -164,6 +177,25 @@
          !   WRITE(numout,*) 'za_i(ji,jpl)=',za_i(ji,:)
          !ENDIF
-            
+         
+         ENDIF ! if zhti > 0
+
       END DO ! i loop
+
+      ! ------------------------------------------------
+      ! Adding Snow in each category where za_i is not 0
+      ! ------------------------------------------------ 
+      DO jl = 1, jpl
+         DO ji = 1, ijpij
+            IF( za_i(ji,jl) > 0._wp ) THEN
+               zht_s(ji,jl) = zht_i(ji,jl) * ( zhts(ji) / zhti(ji) )
+               ! In case snow load is in excess that would lead to transformation from snow to ice
+               ! Then, transfer the snow excess into the ice (different from limthd_dh)
+               zdh = MAX( 0._wp, ( rhosn * zht_s(ji,jl) + ( rhoic - rau0 ) * zht_i(ji,jl) ) * r1_rau0 ) 
+               ! recompute ht_i, ht_s avoiding out of bounds values
+               zht_i(ji,jl) = MIN( zhi_max(jl), zht_i(ji,jl) + zdh )
+               zht_s(ji,jl) = MAX( 0._wp, zht_s(ji,jl) - zdh * rhoic / rhosn )
+            ENDIF
+         ENDDO
+      ENDDO
 
       IF( nn_timing == 1 )  CALL timing_stop('limcat_1D')
Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limhdf.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limhdf.F90	(revision 4220)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limhdf.F90	(revision 4332)
@@ -29,5 +29,5 @@
 
    LOGICAL  ::   linit = .TRUE.              ! initialization flag (set to flase after the 1st call)
-   REAL(wp) ::   epsi04 = 1e-04              ! constant
+   REAL(wp) ::   epsi04 = 1.e-04              ! constant
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   efact   ! metric coefficient
 
@@ -54,7 +54,7 @@
       REAL(wp), DIMENSION(jpi,jpj), INTENT( inout ) ::   ptab    ! Field on which the diffusion is applied
       !
-      INTEGER  ::  ji, jj            ! dummy loop indices
-      INTEGER  ::  its, iter, ierr   ! local integers
-      REAL(wp) ::   zalfa, zrlxint, zconv, zeps   ! local scalars
+      INTEGER  ::  ji, jj                   ! dummy loop indices
+      INTEGER  ::  its, iter, ierr          ! local integers
+      REAL(wp) ::   zalfa, zrlxint, zconv   ! local scalars
       REAL(wp), POINTER, DIMENSION(:,:) ::   zrlx, zflu, zflv, zdiv0, zdiv, ztab0
       CHARACTER(lc) ::   charout   ! local character
@@ -79,5 +79,4 @@
       zalfa = 0.5_wp                      ! =1.0/0.5/0.0 = implicit/Cranck-Nicholson/explicit
       its   = 100                         ! Maximum number of iteration
-      zeps  =  2._wp * epsi04
       !
       ztab0(:, : ) = ptab(:,:)      ! Arrays initialization
@@ -94,5 +93,5 @@
       iter  = 0
       !
-      DO WHILE( zconv > zeps .AND. iter <= its )   ! Sub-time step loop
+      DO WHILE( zconv > ( 2._wp * epsi04 ) .AND. iter <= its )   ! Sub-time step loop
          !
          iter = iter + 1                                 ! incrementation of the sub-time step number
Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90	(revision 4220)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90	(revision 4332)
@@ -76,4 +76,7 @@
       !!                6) Lateral boundary conditions
       !!
+      !! ** Notes   : o_i, t_su, t_s, t_i, s_i must be filled everywhere, even
+      !!              where there is no ice (clem: I do not know why but it is mandatory) 
+      !!
       !! History :
       !!   2.0  !  01-04  (C. Ethe, G. Madec)  Original code
@@ -84,5 +87,5 @@
       !! * Local variables
       INTEGER    :: ji, jj, jk, jl             ! dummy loop indices
-      REAL(wp)   :: epsi06, epsi20, ztmelts
+      REAL(wp)   :: epsi20, ztmelts, zdh
       INTEGER    :: i_hemis, i_fill, jl0  
       REAL(wp)   :: ztest_1, ztest_2, ztest_3, ztest_4, ztests, zsigma, zarg, zA, zV, zA_cons, zV_cons, zconv
@@ -98,5 +101,4 @@
       CALL wrk_alloc(   2,      zhm_i_ini, zat_i_ini, zvt_i_ini, zhm_s_ini, zsm_i_ini )
 
-      epsi06   = 1.0e-6
       epsi20   = 1.0e-20
       IF(lwp) WRITE(numout,*)
@@ -308,6 +310,5 @@
       !---------------------------------------------------------------------
 
-      ! Ice concentration, thickness and volume, snow depth, ice
-      ! salinity, ice age, surface temperature
+      ! Ice concentration, thickness and volume, ice salinity, ice age, surface temperature
       DO jl = 1, jpl ! loop over categories
          DO jj = 1, jpj
@@ -315,10 +316,18 @@
                a_i(ji,jj,jl)   = zidto(ji,jj) * za_i_ini (jl,zhemis(ji,jj))  ! concentration
                ht_i(ji,jj,jl)  = zidto(ji,jj) * zht_i_ini(jl,zhemis(ji,jj))  ! ice thickness
-               ht_s(ji,jj,jl)  = zidto(ji,jj) * zhm_s_ini(zhemis(ji,jj))     ! snow depth
-               sm_i(ji,jj,jl)  = zidto(ji,jj) * zsm_i_ini(zhemis(ji,jj))     ! salinity
+               ht_s(ji,jj,jl)  = ht_i(ji,jj,jl) * ( zhm_s_ini( zhemis(ji,jj) ) / zhm_i_ini( zhemis(ji,jj) ) )  ! snow depth
+               sm_i(ji,jj,jl)  = zidto(ji,jj) * zsm_i_ini(zhemis(ji,jj)) + ( 1._wp - zidto(ji,jj) ) * s_i_min ! salinity
                o_i(ji,jj,jl)   = zidto(ji,jj) * 1._wp + ( 1._wp - zidto(ji,jj) ) ! age
-               t_su(ji,jj,jl)  = zidto(ji,jj) * 270.0 + ( 1._wp - zidto(ji,jj) ) * t_bo(ji,jj) ! surf temp
- 
-               ! ice volume, snow volume, salt content, age content
+               t_su(ji,jj,jl)  = zidto(ji,jj) * 270.0 + ( 1._wp - zidto(ji,jj) ) * 270.0 ! surf temp
+
+               ! This case below should not be used if (ht_s/ht_i) is ok in namelist
+               ! In case snow load is in excess that would lead to transformation from snow to ice
+               ! Then, transfer the snow excess into the ice (different from limthd_dh)
+               zdh = MAX( 0._wp, ( rhosn * ht_s(ji,jj,jl) + ( rhoic - rau0 ) * ht_i(ji,jj,jl) ) * r1_rau0 ) 
+               ! recompute ht_i, ht_s avoiding out of bounds values
+               ht_i(ji,jj,jl) = MIN( hi_max(jl), ht_i(ji,jj,jl) + zdh )
+               ht_s(ji,jj,jl) = MAX( 0._wp, ht_s(ji,jj,jl) - zdh * rhoic / rhosn )
+
+               ! ice volume, salt content, age content
                v_i(ji,jj,jl)   = ht_i(ji,jj,jl) * a_i(ji,jj,jl)              ! ice volume
                v_s(ji,jj,jl)   = ht_s(ji,jj,jl) * a_i(ji,jj,jl)              ! snow volume
